%This script Runs the OHBW-OOMP methods for approximating signals using:
%a)A Trigonometric Dictionary (DT)
%b)A  Mixed dictionary which is the union of a DT and a dictionary rusulting by translations of pulses as described in [1].
%The inputs are set to reproduce the 3 examples in [1].
%By defaut it runs Example 1 (gw151226.wav clip) to change
%the example change clipcase at line 15
%To set different options please read the comments in the  get_inputs files:
%
%
%Ref:[1] Sparse Representation of Gravitational Sound
%Laura Rebollo Neira and Angel Plastino
%
%======================Change the value below to change the example=====================
%
Clip=1 %to test the other clips change to 2 or 3
%
%To use other settings for the same clip change the file: get_inputs_clip1
%=======================================================================================

switch Clip
case 1
get_inputs_clip1
case 2
get_inputs_clip2
case 3
get_inputs_clip3
   otherwise
   disp('unknown option');
end
%
%
[s1,s2]=size(signal);
if s1< s2; signal=signal';end
f=signal';
%
%
L=bw
N=bw*a
%
[nordt]=NormTrgDict(bw,a,icase); %get the normalization factors
%
clear eex
eex=[]; %phase factors for  inner products via FFT
M=N; 
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nordt(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nordt(1,:);;
end
if icase==4
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nordt(2,:);;
end

%
ov=0; %to allow overlap in the partition change ov
clear cmf
%
[cmf,Nframe]=BlockOverlap(f',bw,ov);
%
NBX=Nframe;
%
No=numel(f);;
zero_frame=0;
%
tic;
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 kap mk cf cf2 cfs nf
tic;
tol3=(norm(f)^2/(10^(pss/10)));
[h,Di1,beta,c,Q,Nat]=OHBW_OOMP_FFT_MixD(cmf,DT,tol3,No,eex,icase,hat,dicl); for q=1:size(c,1);c{q}=c{q}';end;
%
%=====================================================================
%recover the signla from overlapping parameters
[fa]=JointOverlap(h,bw,ov,Nframe);

%=====================================================================
dh=[];
clear kk  kl  
for i=1:Nframe
kk(i)=numel(Di1{i});
dh=[dh Di1{i}];
end 
if ov==0 
clear t qq qt kt kl
%figure(2)
%hist(dh(:));
t=1:numel(f);
t=t/fs;
qq=1:Nframe; qq=qq*bw;
qt=(qq-bw/2)/fs;
figure(3)
plot(t,f,'y',qt,kk/bw,'k')
Group_Ind
figure(4)
plot(t,f,'y',qt,kk/bw,'k',qt,kt/bw,'r',qt,kl/bw,'b')

fprintf('===============================================\n')
%
end
 fprintf(' Sparsity Ratio SR.\n');
%

SR= numel(fa)/Nat% Sparsity ratio
%
toc
 fprintf(' Approximation quality SNR.\n');
%
na=numel(fa);
SNR= CalcSNR(f(1:na),fa')
fprintf('===============================================\n')
MSE=norm(fa'-f(1:na))^2/numel(fa); % MSE of the approximation
noise=fa'-f(1:na);
mean_noise=mean(noise)
var_noise=var(noise)
return
