%This script Runs the OOMP methods for approximating signals using:
%a)A Trigonometric Dictionary (DT)
%b)A  Mixed dictionary which is the union of a DT and a dictionary rusulting by translations of pulses as described in [1].
%The inputs are set to reproduce the 3 examples in [1].
%By defaut it runs Example 1 (gw151226.wav clip) to change
%the example change Clip case at line 15
%To set different options please read the comments in the  get_inputs files:
%
%Ref:[1] Sparse Representation of Gravitational Sound
%Laura Rebollo Neira and Angel Plastino
%
%
%======================Change the value below to change the example=====================
%
Clip=1 %to test the other clips change to 2 or 3
%
%To use other settings for the same clip change the file: get_inputs0_clip1
%=======================================================================================

switch Clip
case 1
get_inputs0_clip1
case 2
get_inputs0_clip2
case 3
get_inputs0_clip3
   otherwise
   disp('unknown option');
end
%

%
[s1,s2]=size(signal);
if s1< s2; signal=signal';end
%

option=icase;

%
[cmf,Nframe,mf]=BlockSignal(signal,bw); %makes the partition
%======end the segmentation each cmf is a cell 
delta=1;
%
indx=[]; %do not touch 
%
[FrameLength, N]=size(DT);
%
%Caculate the phaces to calculate inner products with fft (eq      )
clear eex
M=N;
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nord(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nord(1,:);
end
if icase==4  
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nord(2,:);
end

No=bw;
mfc=cell(Nframe,1);
c1=cell(Nframe,1);
nCoe=0;
zero_frame=0;
%
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 kk
tic;
for j=1:Nframe;
%cmf{j}=cmf{j}';
tol=sqrt(norm(cmf{j})^2/(10^(pss/10)));
if (norm(cmf{j})^2)*delta> tol_zero_frame %avoids to approximate zero block
%
[h{j},cDi1{j},beta,c{j},cQ,norQ]=OOMP_FFT_MixD(cmf{j},DT,tol,No,eex,icase,hat,dicl);%
%
%======== save the coefficients 'c' and indices 'cDi1' and approximated blocks 'h'
%k0=numel(c{j});
kk(j)=numel(c{j});
nCoe = nCoe + kk(j); %number of coeffients in the frames
else
h{j}=zeros(bw,1).'; %zero frame
nCoe = nCoe + 1;     
kk(j)=1;%counts 1 coefficient (zero) per zero frame

zero_frame=zero_frame+1; %numbers of zero frame
end
end
%
%=====================================================================
clear msignal
fa=[];
for i=1:Nframe
%h{i}=h{i}'; %uncomment if tunning OMP_mtestFFT
cmf{i}=cmf{i}';
fa=[fa h{i}];%get the whole signal from the frames 
end
%
qq=1:Nframe; qq=qq*bw;
fprintf('===============================================\n')
;

 fprintf('OOMP Sparsity Ratio SR.\n');

SR= numel(mf)/nCoe% Sparsity ratio
No=nCoe %numer of atoms

fprintf('OOMP Approximation quality SNR.\n');

SNR= CalcSNR(mf,fa)

fprintf('===============================================\n')
MSE=norm(fa-mf)^2/numel(mf); % MSE of the approximation
noise=fa-mf;
mean_noise=mean(noise)
var_noise=var(noise)
t=1:numel(mf);
t=t/fs;
qt=(qq-bw/2)/fs;
plot(t,mf,qt,kk/bw)
toc
return


