function [cmf,Nframe,f2]=BlockSignal(f,bw);
%inputs
%
%f signal
%bw length of the block 
%
%outputs
%cmf cells of size (bw,1)
%Nframe num of blocks
%f2 re-sized signal if f can't be exacly split.
%
s=floor(numel(f)/bw);
f2=f(1:s*bw)'; 
Nx=numel(f2);
if Nx < numel(f) 
fprintf('A %i signal cannot be split exactly into frames of width %i. It has been re-sized, \n', numel(f),bw);
end
Nframe=Nx/bw;
cmf=cell(Nframe,1);
t0=1;
for j=1:Nframe;
t=t0:t0+bw-1;
t0=t0+bw;
cmf{j}=f2(t);
end
